﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_to_from_ragged
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            int num_rows = int.Parse(txtNumRows.Text);
            int num_cols = int.Parse(txtNumCols.Text);

            // Create a two-dimensional array.
            string[,] array2d = new string[num_rows, num_cols];
            for (int r = 0; r < num_rows; r++)
                for (int c = 0; c < num_cols; c++)
                    array2d[r, c] = "(" + r.ToString() + ", " + c.ToString() + ")";

            // Copy into a ragged array and display it.
            string[][] ragged = array2d.ToRagged();
            txtRaggedArray.Text = ragged.Dump("\t", "\r\n");

            // Copy back into a two-dimensional array and display it.
            array2d = ragged.To2DArray();
            txt2DArray.Text = array2d.Dump("\t", "\r\n");
        }
    }
}
